#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <dplay.h>
#include <math.h>
#include <stdio.h>
#include "resource.h"
#include "Com.h"

HWND Dlg;

BOOL CALLBACK DlgProc(HWND,UINT,WPARAM,LPARAM);

unsigned List[10000],NL=0;
int Exit=0;

int IsPrime(unsigned long n)
{
	if(n<1l || n==4l) return 0;
	for(unsigned i=1;sqrt((DWORD)(double)n)>List[i];i++) if((n)%(long)(List[i]) == 0) return 0;
	return 1;
}

BOOL WriteToFile(unsigned long left,unsigned long right,char * fname)
{
	HANDLE f = CreateFile(fname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
	char buff[30000]="",s[10];
	for(unsigned long i=left;i<right;i++) if(IsPrime(i))
	{
		sprintf(s,"%ld\n",i);
		strcat(buff,s);
	}
	DWORD wr;
	WriteFile(f,buff,strlen(buff),&wr,NULL);
	CloseHandle(f);
	return TRUE;
}

int WINAPI WinMain(HINSTANCE m_HI,HINSTANCE,LPSTR,int)
{
	MSG msg;
	Dlg = CreateDialog(m_HI,MAKEINTRESOURCE(IDD_DIALOG1),NULL,DlgProc);
	ShowWindow(Dlg,SW_SHOW);

	unsigned i,k,f;
	int A[50000];
	for(i=0;i<50000;i++) A[i]=1;
	for(i=2;i<500;i++)
	{
		for(f=max(4,i+1);((f%i) != 0);) f++;
		for(k=f;k<50000;k+=i) A[k]=0;
	}
	for(i=1;i<50000;i++) if(A[i]) List[NL++] = i;
	char s[10];
	itoa(NL,s,10);
	MessageBox(Dlg,s,s,0);

	CoInitialize(NULL);
	if(!InitDP())
	{
		MessageBox(Dlg,"InitDirectPlay","Error",0);
		//DestroyWindow(Dlg);
		//goto EXIT;
	}

	while(1)
	{
		if(Exit) goto EXIT;
		while(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if(!IsDialogMessage(Dlg,&msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			if(msg.message==WM_QUIT) break;
		}
	}

EXIT:
	TermDP();
	return msg.wParam;
}

BOOL CALLBACK DlgProc(HWND wnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg)
	{
	case WM_CLOSE:
		DestroyWindow(Dlg);
		return TRUE;
	case WM_DESTROY:
		PostQuitMessage(0);
		Exit=1;
		return TRUE;
	case WM_COMMAND:
		switch(wParam)
		{
		case IDC_OK:
			char ls[50],rs[50];
			GetWindowText(GetDlgItem(wnd,IDC_EDIT1),ls,50);
			GetWindowText(GetDlgItem(wnd,IDC_EDIT2),rs,50);
			unsigned long left = atol(ls);
			unsigned long right = atol(rs);
			WriteToFile(left,right,"8server.res");
			MessageBox(Dlg,"Saved to file \"8server.res\"","8Server",0);
		}
		return TRUE;
	}
	return FALSE;
}